package example_binary_search;
import java.util.Arrays;

public class BinarySearchTest {

	public static void main(String[] args) {
		int[] vals = new int[] {1,4,8,10,17,33};
		int[] keys = {-4,3,5,9,12,28,99};

		System.out.println( "vals=" + Arrays.toString( vals ) );

		for(int key : keys) {
			
			int index = binarySearch( vals, key );
			System.out.println( "\nkey=" + key + ", index=" + index );
			
			if( index < 0 ) { // key not found
				int loc = -1*index - 1; // find where key belongs
				System.out.println( "Key belongs at index:" + loc );
				int max; // find next value greater than key
				if(loc < vals.length) {
					max = vals[loc];
				}
				else {
					max = Integer.MAX_VALUE;
				}
				System.out.println( "Next value greater than key: " + max );
			}
		}
	}

	public static int binarySearch( int[] vals, int key ) {
			return binarySearch( vals, key, 0, vals.length-1 );
	}
	
	private static int binarySearch( int[] vals, int key, int low, int high ) {
	
		if( low > high )
			return -(low+1);
		else {
			int mid = (low+high)/2;
	
			if( key < vals[mid] )
				return binarySearch( vals, key, low, mid-1 );
			else if( key > vals[mid] )
				return binarySearch( vals, key, mid+1, high );
			else
				return mid;
		}
	}

}



