package example_print_folder;

import java.io.File;
import java.util.ArrayList;


public class ListFiles
{
	public static void main(String[] args) 
	{
	// Would need to create a folder structure, and point the file in the correct
	// place to use code..
		File folder = new File("src\\example_print_folder\\abc");
		
		// Not sure what difference in versions is
		System.out.println("printFolder()");
		printFolder(folder);
		
		System.out.println("\n\nprintFolder2()");
		printFolder2(folder);
		
		System.out.println("\n\nprintFolder3()");
		printFolder3(folder);

		System.out.println("\n\nprintFolderWithIndent()");
		printFolderWithIndent(folder, "");

		System.out.println("\n\nGet list of files (correct)");
		ArrayList<File> files = getFiles(folder);
		for( File f : files ) {
			System.out.println(f.getAbsolutePath());
		}
		
		System.out.println("\nGet list of files (incorrect)-nothing printed");
		ArrayList<File> files2 = incorrectGetFiles(folder);
		for( File f : files2 ) {
			System.out.println(f.getAbsolutePath());
		}
	}

	private static void printFolder( File folder ) {
	   if( !folder.isDirectory() ) {
		   System.out.println( folder.getName() + ":file" );
	   }
	   else {
		   System.out.println( folder.getName() + ":folder" );
      
		   File[] files = folder.listFiles();
         
		   for( File f : files ) {
			   printFolder( f );
		   }
	   }
	}

	public static ArrayList<File> getFiles( File folder ) {
		ArrayList<File> files = new ArrayList<>();
		getFiles( folder, files );
		return files;
	}
	
	private static void getFiles( File folder, ArrayList<File> files ) {
	   if( !folder.isDirectory() ) {
		   files.add(folder);
	   }
	   else {
		   File[] localFiles = folder.listFiles();
		   
		   if( localFiles.length == 0 )
			   return;
	     
		   for( File f : localFiles ) {
			   getFiles( f, files );
		   }
	   }		
	}

	private static ArrayList<File> incorrectGetFiles( File folder ) {
		ArrayList<File> files = new ArrayList<>();
		if( !folder.isDirectory() ) {
			files.add(folder);
			return files;
		}
		else {
			File[] localFiles = folder.listFiles();
		   
			for( File f : localFiles ) {
				incorrectGetFiles( f );
			}
			return files;
		}

	}

   private static void printFolder2( File folder)
   {
      System.out.println( folder.getName() + ":folder" );
		File[] files = folder.listFiles();
      
      for( File f : files )
      {
			if( !f.isDirectory() )
	         System.out.println( f.getName() + ":file" );
	      else
            printFolder2( f );
      }
   }


   private static void printFolder3( File folder )
   {
		printFolderWithIndent( folder, "" );
   }


   private static void printFolderWithIndent( File f, String indent )
   {

      System.out.println( indent + f.getName() + ":folder" );
		indent += "    ";
      File[] files = f.listFiles();
      
      for( File f2 : files )
      {
			if( !f2.isDirectory() )
	         System.out.println( indent + f2.getName() + ":file" );
	      else
            printFolderWithIndent( f2, indent );
      }
   }
	
}