package example_select_sort_integers;
import java.util.Arrays;

public class SelectSortTest
{

	public static void main(String[] args)
	{
		int[][] vals1 = { {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
		int[][] vals2={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
		int[][] vals3={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
		int[][] vals4={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };


/*		findMinAndSwap(vals, 0);
		System.out.println( Arrays.toString( vals ) );
		findMinAndSwap(vals, 1);
		System.out.println( Arrays.toString( vals ) );
*/
		for( int i=0; i<vals1.length; i++) {

			System.out.print( "Original: " + Arrays.toString( vals1[i] ) );
			selSortIterative(vals1[i]);
			System.out.println( ", Iterative: " + Arrays.toString( vals1[i] ) );

			System.out.print( "Original: " + Arrays.toString( vals2[i] ) );
			selSortRecursive(vals2[i]);
			System.out.println( ", Recursive: " + Arrays.toString( vals2[i] ) );

			System.out.print( "Original: " + Arrays.toString( vals3[i] ) );
			selectSort(vals3[i]);
			System.out.println( ", Recursive2: " + Arrays.toString( vals3[i] ) );

			System.out.print( "Original: " + Arrays.toString( vals4[i] ) );
			selectSort2(vals4[i]);
			System.out.println( ", Recursive3: " + Arrays.toString( vals4[i] ) );
			System.out.println();

		}
	}

	public static void selectSort2(int[] vals) {
		if( vals.length > 1 )
			selectSort2(vals, vals.length-1);
	}

	private static void selectSort2(int[] vals, int endPos) {
		if(endPos>0) {
//			int maxIndex = findIndexOfMax(vals,endPos);
			int maxIndex = findIndexOfMaxRecursive(vals,endPos);
			swap(vals, maxIndex, endPos);
			selectSort2(vals, endPos-1);
		}
	}

	private static int findIndexOfMax(int[] vals, int pos) {
		int maxValue = vals[0];
		int maxIndex = 0;
		for(int i=1; i<=pos; i++) {
			if(vals[i] > maxValue) {
				maxValue = vals[i];
				maxIndex = i;
			}
		}
		return maxIndex;
	}

	private static int findIndexOfMaxRecursive(int[] vals, int pos) {
		return findIndexOfMaxRecursive(vals, pos, 0);
	}

	private static int findIndexOfMaxRecursive(int[] vals, int pos, int maxIndex) {
		if(pos==0) {
			return maxIndex;
		}
		if(vals[pos] > vals[maxIndex]) {
				maxIndex = pos;
		}
		return findIndexOfMaxRecursive(vals, pos-1, maxIndex);

	}

	private static void swap(int[] vals, int loc1, int loc2) {
		int valLoc1 = vals[loc1];
		vals[loc1]=vals[loc2];
		vals[loc2]=valLoc1;
	}

	private static void selectSort( int[] vals )
	{
		if( vals.length > 1 )
			selectSort( vals, vals.length-1 );
	}

	private static void selectSort( int[] vals, int endPos ) {
		int maxValue = vals[0];
		int maxIndex = 0;

		// Base case: list is sorted when
		// only 1 element left.
		if(endPos<1)
			return;

		// Find max
		for( int i=1; i<=endPos; i++ )
			if( vals[i] > maxValue ) {
				maxValue = vals[i];
				maxIndex = i;
			}

		// Swap max with value in endPos.
		int lastVal = vals[endPos];
		vals[endPos] = maxValue;
		vals[maxIndex] = lastVal;

		// Recurse with a shorter list
		selectSort( vals, endPos-1 );
	}

	private static void selSortIterative( int[] vals ) {

		if( vals.length > 1 )
			for(int i=0; i<vals.length-1; i++)
				findMinAndSwap( vals, i );
	}

	private static void selSortRecursive( int[] vals ) {
		if( vals.length > 1 )
			selSortRecursive( vals, 0 );
	}

	private static void selSortRecursive( int[] vals, int startPos ) {
		if( startPos == vals.length-1 )
			return;

		findMinAndSwap(vals, startPos);
		selSortRecursive(vals, startPos+1);
	}

	private static void findMinAndSwap( int[] vals, int startPos ) {

		int minValue = vals[startPos];
		int minIndex = startPos;

		for( int i=startPos+1; i<vals.length; i++ )
			if( vals[i] < minValue )
			{
				minValue = vals[i];
				minIndex = i;
			}

		// swap: min goes to startPos, startPos goes to min.
		vals[minIndex] = vals[startPos];
		vals[startPos] = minValue;

	}

	private static void selSort( int[] vals )
	{
		if( vals.length > 1 )
			selSort( vals, 0 );
	}

	private static void selSort( int[] vals, int startPos )
	{
//		System.out.println( "sel sort: startPos=" + startPos + ", length=" + (vals.length-1) );
		if( startPos == vals.length-1 ) return;
		// find min.
		int minValue = Integer.MAX_VALUE;
		int minIndex = -1;

		for( int i=startPos; i<vals.length; i++ )
			if( vals[i] < minValue )
			{
				minValue = vals[i];
				minIndex = i;
			}

//		System.out.println( Arrays.toString( vals ) + " :start " + startPos + ", min val " + minValue + ", min inx" + minIndex );

		// swap max with current last.
		vals[minIndex] = vals[startPos];
		vals[startPos] = minValue;

		selSort( vals, startPos+1 );
	}

}



