package example_select_sort_person;
import java.util.ArrayList;
import java.util.Arrays;

public class SelectSortPerson
{

	public static void main(String[] args) {
		ArrayList<Person> people = new ArrayList<>(Arrays.asList(new Person("Dave",9), new Person("Ram", 5),
				new Person("Roo",18), new Person("Sal", 6)));

		selectSort(people);

		System.out.println(people);
	}

	public static void selectSort(ArrayList<Person> people) {
		if(people.size()>1)
			selectSort(people, people.size()-1);
	}

	private static void selectSort(ArrayList<Person> people, int endPos) {
		Person maxPerson = people.get(0);
		int maxIndex = 0;

		// Base case
		if(endPos<1)
			return;

		// Find max
		for( int i=1; i<=endPos; i++ ) {
			if(people.get(i).compareTo(maxPerson)>0) {
				maxPerson = people.get(i);
				maxIndex = i;
			}
		}
		// Swap max with value in endPos.
		Person lastPerson = people.get(endPos);
		people.set(endPos, maxPerson);
		people.set(maxIndex, lastPerson);

		// Recurse with a shorter list
		selectSort(people, endPos-1);
	}

}



