package example_select_sort_person;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;

public class SelectSortPersonComparator {

	public static void main(String[] args) {
		ArrayList<Person> people = new ArrayList<>(Arrays.asList(new Person("Dave",9), new Person("Ram", 5),
				new Person("Roo",18), new Person("Sal", 6)));

		selectSort(people, new PersonNameComparator());

		System.out.println(people);
	}

	private static void selectSort( ArrayList<Person> people, Comparator<Person> comp ) {
		if( people.size() > 1 )
			selectSort( people, people.size()-1, comp);
	}

	private static void selectSort( ArrayList<Person> people, int endPos, Comparator<Person> comp ) {
		Person maxPerson = people.get(0);
		int maxIndex = 0;

		// Base case: list is sorted when
		// only 1 element left.
		if(endPos<1)
			return;

		// Find max
		for( int i=1; i<=endPos; i++ ) {
			if(comp.compare(people.get(i), maxPerson)>0) {
				maxPerson = people.get(i);
				maxIndex = i;
			}
		}
		// Swap max with value in endPos.
		Person lastPerson = people.get(endPos);
		people.set(endPos, maxPerson);
		people.set(maxIndex, lastPerson);

		// Recurse with a shorter list
		selectSort( people, endPos-1, comp );
	}

}



