package examples_helper_store_intermediate;

import java.util.Arrays;

public class MinInt {
	public static void main(String[] args) {
		int[][] testCases = { {1,2,3}, {3,2,1}, {8, 2, 9, -6, 18, -33, 49} };
		for(int n=0; n<testCases.length; n++) {
			int[] vals = testCases[n];
			int minVal = minInt(vals);
			String msg = String.format("vals=%s, min=%d\n", Arrays.toString(vals), minVal);
			System.out.println(msg);
		}
	}
	
	public static int minInt(int[] vals) {
		if(vals.length > 0) {
			return minInt(vals, 0, Integer.MAX_VALUE);
		}
		return Integer.MIN_VALUE;
	}
	
	private static int minInt(int[] vals, int pos, int minVal ) {
		if(pos >= vals.length) {
			return minVal;
		}
		if(vals[pos] < minVal) {
			minVal = vals[pos];
		}
		return minInt(vals, ++pos, minVal);
	}
	
	public static int minIntIncorrect(int[] vals) {
		if(vals.length > 0) {
			return minIntIncorrect(vals, 0);
		}
		return Integer.MIN_VALUE;
	}
	
	private static int minIntIncorrect(int[] vals, int pos) {
		int minVal = vals[0];
		if(pos >= vals.length) {
			return minVal;
		}
		if(vals[pos] < minVal) {
			minVal = vals[pos];
		}
		return minIntIncorrect(vals, ++pos);
	}

}



