package examples_helper_store_intermediate;
import java.util.ArrayList;
import java.util.Arrays;

public class MinString {
	public static void main(String[] args) {
		ArrayList<ArrayList<String>> testData = new ArrayList<ArrayList<String>>(
				Arrays.asList(
						new ArrayList<String>(Arrays.asList("a", "ab", "abcd", "xy", "xyz")), 
						new ArrayList<String>(Arrays.asList("abc", "xyz", "a", "zz", "abcd")), 
						new ArrayList<String>(Arrays.asList("abc", "ab", "abcd", "zz", "a")), 
						new ArrayList<String>(Arrays.asList("a")),
						new ArrayList<String>() 
				));
		
//		ArrayList<String> vals = new ArrayList<>(
//				Arrays.asList("abc", "ab", "ddefg", "zz", "kade"));
//		String minLenStr = minString(vals);
		
		for(ArrayList<String> vals : testData) {
			String msg = String.format("minString(%s)=%s", vals, minString(vals));
			System.out.println(msg);

//			msg = String.format("minStringIncorrect(%s)=%s", vals, minStringIncorrect(vals));
//			System.out.println(msg);
		}
	}
	
	public static String minString(ArrayList<String> strs) {
		if(strs.size()==0 || strs==null) {
			return null;
		}
		return minString(strs, 0, strs.get(0));
	}
	
	private static String minString(ArrayList<String> strs, int loc, String minStr) {
		if(loc==strs.size()) {  // base case
			return minStr;
		}
		// Recursive step. First, check to see if
		// cur string is shorter than cur min
		if(strs.get(loc).length()<minStr.length()) {
			minStr = strs.get(loc);
		}
		return minString(strs, loc+1, minStr);
	}
	
	public static String minStringIncorrect(ArrayList<String> strs) {
		if(strs.size()==0 || strs==null) {
			return null;
		}
		return minStringIncorrect(strs, 0);
	}

	// Incorrect version
	private static String minStringIncorrect(ArrayList<String> strs, int loc) {
		String minStr="";
		if(loc==strs.size()) {  // baseCase
			return minStr;
		}
		// Recursive step. First, check to see if
		// cur string is shorter than cur min
		if(strs.get(loc).length()<minStr.length()) {
			minStr = strs.get(loc);
		}
		
		return minStringIncorrect(strs, loc+1);
	}

	
	
}



