package examples_primitive_no_helper;

public class SumSeries {
	/*
	 *  m(n) = 1 + 1/2 + 1/3 + ... + 1/n
	 */
	public static void main(String[] args) {
		int max = 10;

		System.out.println("recur, iter, diff");
		for(int i=1; i<max; i++) {
			double recur = m(i);
			double iterative = sumSeriesIterative(i);
			double diff = recur - iterative;
			String msg = String.format("n=%d - %,.6f, %,.6f, %,.6f", i, recur, iterative, diff);
	 		System.out.println(msg);
		}
	}

	private static double m(int n) {
		if(n<=1) {  // base case
			return 1;
		}
		return m(n-1) + 1.0/n;	// recursive step
	}
	
	private static double sumSeriesIterative( long n ) {
		double sum = 1.0;
		for(long i=2; i<=n; i++ ) {
			sum += 1.0/i;
		}
		return sum;
	}
}



