package exercise_binary_search;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

public class BinarySearchTest {

	public static void main(String[] args) {
		ArrayList<Employee> emps = new ArrayList<>(Arrays.asList(
				new Employee("Eardle", "Bee"),
				new Employee("Fontaine", "Ann"),
				new Employee("Ardly", "Steve"),
				new Employee("Zeephus", "Xavier"),
				new Employee("Plutarch", "Rhen"),
				new Employee("Bently", "Justine"),
				new Employee("Zeephus", "Anne"),
				new Employee("Cauthen", "Dirk"),
				new Employee("Millhouse", "Milly")
				));
		
		ArrayList<Employee> keys = new ArrayList<>(Arrays.asList(
				new Employee("Jones", "Hugh"),
				new Employee("Fontaine", "Ann"),
				new Employee("Fontaine", "Steve"),
				new Employee("Zeephus", "Xavier")
				));

		Collections.sort(emps);
		System.out.println("emps=" + emps );

		for(Employee key : keys) {
			int index = binarySearch(emps, key);
			System.out.println( "\nkey=" + key + ", index=" + index );
			
			if( index < 0 ) { // key not found
				int loc = -1*index - 1; // find where key belongs
				System.out.println( "Key belongs at index:" + loc );
			}
		}
	}

	public static int binarySearch( ArrayList<Employee> emps, Employee emp ) {
			return binarySearch(emps, emp, 0, emps.size()-1);
	}
	
	private static int binarySearch( ArrayList<Employee> emps, Employee emp, int low, int high ) {
		if(low > high)
			return -(low+1);
		else {
			int mid = (low+high)/2;
			if(emp.compareTo(emps.get(mid)) < 0) {
				return binarySearch( emps, emp, low, mid-1 );
			}
			else if(emp.compareTo(emps.get(mid)) > 0) {
				return binarySearch( emps, emp, mid+1, high );
			}
			else {
				return mid;
			}
		}
	}

}



