package exercise_binary_search;

/**
 * Compares on last name and then first name.
 * @author dgibson
 *
 */
public class Employee implements Comparable<Employee> {
	private String lastName;
	private String firstName;

	public Employee(String lastName, String firstName) {
		this.lastName = lastName;
		this.firstName = firstName;
	}

	public String getLastName() { return lastName; }

	public String getFirstName() { return firstName; }

	public int compareTo( Employee other ) {
		int diffLName = this.lastName.compareTo(other.lastName);

		if(diffLName != 0)
			return diffLName;
		else
			return this.firstName.compareTo(other.firstName);
	}
	
	public boolean equals(Object o) {
		if(o instanceof Employee) {
			Employee other = (Employee)o;
			return this.lastName.equals(other.lastName) &&
			       this.firstName.equals(other.firstName);
		}
		return false;
	}

	public String toString()
	{
		return "(" + lastName + ", " + firstName + ")";
	}
}

