package exercise_binary_search;

import java.util.*;

public class EmployeeTest {
	public static void main(String[] args) {
		test1();
		test2();
	}

	public static void test1() {
		Employee p1 = new Employee( "Wilson", "Henry" );
		Employee p2 = new Employee( "Jones", "Sherry" );
		Employee p3 = new Employee( "Jones", "Aron" );
		Employee p4 = new Employee( "Jones", "Aron" );

		System.out.println( p1.compareTo(p2) ); // positive
		System.out.println( p2.compareTo(p3) ); // positive
		System.out.println( p2.compareTo(p1) ); // negative
		System.out.println( p3.compareTo(p4) ); // zero
	}

	public static void test2() 	{
		Employee p1 = new Employee("Wilson", "Henry");
		Employee p2 = new Employee("Purns", "Nivel");
		Employee p3 = new Employee("Jones", "Sherry");
		Employee p4 = new Employee("Jones", "Aron");
		Employee p5 = new Employee("Purns", "Nivel");

		Employee[] persons = {p1,p2,p3,p4,p5};

		Arrays.sort( persons );

		System.out.println("Array of Person objects sorted");
		System.out.println(Arrays.toString( persons ) );

		// Or use an array list
 		ArrayList<Employee> persons2 = new ArrayList<Employee>(Arrays.asList(persons));
 		Collections.shuffle(persons2);

// 		persons2.add(p1); persons2.add(p2); persons2.add(p3); persons2.add(p4);

 		Collections.sort( persons2 );

		System.out.println("\nArrayList of Person objects sorted");
 		System.out.println(persons2);

 		
		System.out.println( "\ntestMethodsThatRelyOnComparable()" );

 		Collections.shuffle(persons2);

		System.out.println("Collections.max(persons):" + Collections.max(persons2));
		System.out.println("Collections.min(persons):" + Collections.min(persons2));
		System.out.println("persons.contains(p3)    :" + persons2.contains(p3));
		System.out.println("persons.indexOf(p2)     :" + persons2.indexOf(p2));
		System.out.println("persons.lastIndexOf(p2) :" + persons2.lastIndexOf(p2));
		System.out.println("persons.remove(p1)      :" + persons2.remove(p1));

	}

	public static void testMethodsThatRelyOnComparable() {
		System.out.println( "\ntestMethodsThatRelyOnComparable()" );

		Employee p1 = new Employee( "Wilson", "Henry" );
		Employee p2 = new Employee( "Purns", "Nivel" );
		Employee p3 = new Employee( "Jones", "Sherry" );
		Employee p4 = new Employee( "Jones", "Aron" );
		Employee p5 = new Employee( "Purns", "Nivel" );

		ArrayList<Employee> persons = new ArrayList<Employee>();
		persons.add(p1); persons.add(p2); persons.add(p3); persons.add(p4); persons.add(p5);

		System.out.println("Collections.max(persons):" + Collections.max(persons));
		System.out.println("Collections.min(persons):" + Collections.min(persons));
		System.out.println("persons.contains(p3)    :" + persons.contains(p3));
		System.out.println("persons.indexOf(p2)     :" + persons.indexOf(p2));
		System.out.println("persons.lastIndexOf(p2) :" + persons.lastIndexOf(p2));
		System.out.println("persons.remove(p1)      :" + persons.remove(p1));


 		//Collections.sort(persons);

	}

	public static void printAlphabetical( Employee p1, Employee p2 )
	{
		if( p1.compareTo(p2) <= 0 )
			System.out.println( p1 + "\n" + p2 + "\n" );
		else if( p1.compareTo(p2) > 0 )
			System.out.println( p2 + "\n" + p1 + "\n" );
	}
}

